#include "main.h"

extern p_s PS;
int refill_controller_state;

// 10장에 1초
void refill_paper(int amount)
{
    int i;
    PS.print_current_state = 2; 
    if((amount + PS.current_paper) > MAX_PAPER)
    {
        amount = MAX_PAPER - (PS.current_paper);
    }
    
    for(i = 1; i<(amount+1); i++) // amount 만큼 반복
    {
        if(read_update()) // 새로운 값 입력 들어옴
        {
            int now_command;
            now_command = read_commmand();
            
            switch(now_command)
            {
                case 1 :
                case 2 : 
                printcontroller(now_command);
                break;
                case 3 : 
                case 4 : 
                refillcontroller(now_command);
                break;
                case 5 :
                case 6 : 
                case 7 :
                manageusercontroller(now_command);
                break;
            }
        }
        PS.print_current_state = 2; 
        PS.temp_paper++;
        PS.current_paper ++;
        if(((i%10) == 0) || (amount == i)) // 10장 충전했거나, 마지막 충전 일때
        {
            lcdinterface("admin", 0, 0); // lcd 내부에서 sleep 
        }
    }
    if(PS.wait_num >0)
    {
        read_wait();
    }
}

// 100 에 1초
void refill_ink(int amount)
{
    int i;
    PS.print_current_state = 2; 
    if((amount + PS.current_ink) > MAX_INK) // 최대치로 충전
    {
        amount = MAX_INK - (PS.current_ink);
    }
    
    for(i = 1; i<(amount+1); i++) // amount 만큼 반복
    {
         if(read_update()) // 새로운 값 입력 들어옴
        {
            int now_command;
            now_command = read_commmand();
            
            switch(now_command)
            {
                case 1 :
                case 2 : 
                printcontroller(now_command);
                break;
                case 3 : 
                case 4 : 
                refillcontroller(now_command);
                break;
                case 5 :
                case 6 : 
                case 7 :
                manageusercontroller(now_command);
                break;
            }
        }
        PS.print_current_state = 2;
        PS.temp_ink ++;
        PS.current_ink ++;
        if(((i%100) == 0) || (amount == i)) // 100 충전했거나, 마지막 충전 일때
        {
            lcdinterface("admin", 0, 0); // lcd 내부에서 sleep 
        }
    }
    if(PS.wait_num >0)
    {
        read_wait();
    }
}

void read_refill(r_t * RT)
{
    FILE * fp = fopen("../refill.txt", "r");
    
    fscanf(fp, "%d", &(RT->amount));
    
    fclose(fp);
}


// refillcontroller 
void refillcontroller(int command)
{
    r_t RT;
    int error_code;
    
    read_refill(&RT);   

    if(PS.print_current_state == 0) // 휴식 중이면
    {
        switch(command)
        {
            
            case 3 : // paper
                refill_controller_state = 1;
                if((RT.amount + PS.current_paper)>MAX_PAPER)
                {
                    error_code = 5 ; //충전 하면 최대 용지 량 초과
                    alarm_error(error_code);
                    refill_paper(RT.amount); // 최대치로 충전
                }
                else
                {
                    refill_paper(RT.amount);
                }
                break;
            case 4 : // ink
                refill_controller_state = 2; 
                if((RT.amount + PS.current_ink)>MAX_INK)
                {
                    error_code = 6 ; //충전 하면 최대 잉크 량 초과
                    alarm_error(error_code);
                    refill_ink(RT.amount); // 최대치로 충전
                }
                else
                {
                    refill_ink(RT.amount);
                }
                break;
            
        }
    }
    else if(PS.print_current_state == 1) // 인쇄중
    {
        error_code = 4;
        alarm_error(error_code);
    }
    else if(PS.print_current_state == 2) // 충전중
    {
        error_code = 10;
        alarm_error(error_code);
    }
    
    PS.print_current_state = 0;
}