#pragma once
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "kbhit.h"

#define MAX_PAPER 100
#define MAX_INK 3000

//===========필요한 구조체================
typedef struct print_state
{
    int print_current_state; // 0 휴식중 1 인쇄중 2 충전중
    int current_ink;
    int current_paper;
    int temp_ink;
    int temp_paper; 
    int wait_num;
}p_s;

typedef struct print_text
{
    char * ID;
    char * file;
    int calculated_ink;
    int calculated_paper;
    int verified_file;
}p_t;

typedef struct wait_text
{
    char * ID;
    char * file;
    int paper;
}w_t;

typedef struct refill_txt
{
    int amount; // 충전 량
}r_t;

typedef struct user_txt
{
    char * ID;
    int EI; // exist ID
}u_t;

// ===========각 파일 함수들=============
// main.c
int read_update();
int read_commmand();
int main();

// printcontroller.c
void add_wait(p_t PT);
void read_print(p_t *PT);
void printcontroller(int command);

// refillcontroller.c
void refill_paper(int amount);
void refill_ink(int amount);
void read_refill(r_t * RT);
void refillcontroller(int command);

// manageusercontroller.c
void user_show();
void user_delete(char * ID);
void user_join(char * ID);
void read_user(u_t * UT);
void manageusercontroller(int command);

// printinterface.c
void read_wait();
void emptyBuffer();
void printinterface(w_t WT);

// lcdinterface.c
void lcdinterface(char * ID, int paper, int now_page);
void alarm_error(int error_code);

